org.encog.neural.neat.training.opp

## Class NEATMutateAddNode

- java.lang.Object
- - org.encog.neural.neat.training.opp.NEATMutation
  - - org.encog.neural.neat.training.opp.NEATMutateAddNode

- All Implemented Interfaces:
    EvolutionaryOperator

      public class NEATMutateAddNode
      extends NEATMutation

  Mutate a genome by adding a new node. To do this a random link is chosen. The a neuron is created to split this link. This removes one link and adds two new links. The weights on the new link are created to minimize changes to the values produced by the neuron. ----------------------------------------------------------------------------- http://www.cs.ucf.edu/~kstanley/ Encog's NEAT implementation was drawn from the following three Journal Articles. For more complete BibTeX sources, see NEATNetwork.java. Evolving Neural Networks Through Augmenting Topologies Generating Large-Scale Neural Networks Through Discovering Geometric Regularities Automatic feature selection in neuroevolution

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `NEATMutateAddNode()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `performOperation(Random rnd, Genome[] parents, int parentIndex, Genome[] offspring, int offspringIndex)` Perform the evolutionary operation.

    - ### Methods inherited from class org.encog.neural.neat.training.opp.NEATMutation

      `chooseRandomNeuron, createLink, getElementPos, getOwner, init, isDuplicateLink, isNeuronNeeded, obtainGenome, offspringProduced, parentsNeeded, removeNeuron`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### NEATMutateAddNode

          public NEATMutateAddNode()

  - ### Method Detail

    - #### performOperation

          public void performOperation(Random rnd,
                              Genome[] parents,
                              int parentIndex,
                              Genome[] offspring,
                              int offspringIndex)

      Perform the evolutionary operation.
      Parameters:
        `rnd` - A random number generator.
        `parents` - The parents.
        `parentIndex` - The index into the parents array.
        `offspring` - The offspring.
        `offspringIndex` - An index into the offspring array.

Copyright © 2014. All Rights Reserved.